import * as tslib_1 from "tslib";
import * as React from "react";
import { StyledView } from "./styles/TextField";
var ContentEditable = /** @class */ (function (_super) {
    tslib_1.__extends(ContentEditable, _super);
    function ContentEditable() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = { editing: false };
        _this.selectAll = function () {
            var sel, range;
            if (window.getSelection && document.createRange) {
                range = document.createRange();
                range.selectNodeContents(_this.elem);
                sel = window.getSelection();
                sel.removeAllRanges();
                sel.addRange(range);
            }
        };
        _this.handleKeyDown = function (evt) {
            //exit edit mode on escape key
            if (evt.key === 'Escape') {
                evt.preventDefault();
                _this.elem.blur();
            }
        };
        _this.finishEditing = function () {
            var newValue = _this.elem && _this.elem.innerHTML;
            _this.setState({ editing: false });
            _this.props.onChange(newValue);
        };
        _this.startEditing = function () {
            var _a = _this.props, disabled = _a.disabled, displayContent = _a.displayContent;
            !disabled && _this.setState({ editing: true }, function () { return displayContent && _this.selectAll(); });
        };
        _this.content = function () {
            var _a = _this.props, content = _a.content, displayContent = _a.displayContent;
            return _this.state.editing ? content : displayContent ? displayContent : content;
        };
        return _this;
    }
    ContentEditable.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        return (nextProps.content !== this.props.content ||
            nextProps.disabled !== this.props.disabled ||
            nextState.editing !== this.state.editing);
    };
    ContentEditable.prototype.render = function () {
        var _this = this;
        var _a = this.props, disabled = _a.disabled, onKeyPress = _a.onKeyPress;
        return React.createElement(StyledView, { suppressContentEditableWarning: true, innerRef: function (elem) { return (_this.elem = elem); }, contentEditable: !disabled, placeholder: 'click to edit', dangerouslySetInnerHTML: { __html: this.content() }, onClick: this.startEditing, onBlur: this.finishEditing, onKeyDown: this.handleKeyDown, onKeyPress: onKeyPress });
    };
    ContentEditable.defaultProps = {
        disabled: false,
        onKeyDown: function () { },
        onKeyPress: function () { }
    };
    return ContentEditable;
}(React.Component));
export default ContentEditable;
//# sourceMappingURL=ContentEditable.js.map