import * as tslib_1 from "tslib";
import ContentEditable from "./ContentEditable";
import * as React from "react";
var NumberField = /** @class */ (function (_super) {
    tslib_1.__extends(NumberField, _super);
    function NumberField() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleKeyPress = function (e) {
            if (String.fromCharCode(e.which) !== '-' &&
                String.fromCharCode(e.which) !== '.' &&
                isNaN(Number(String.fromCharCode(e.which)))) {
                e.preventDefault();
            }
        };
        _this.onChange = function (newContent) {
            var newValue = Number(newContent);
            _this.props.onChange(newValue);
        };
        _this.content = function () {
            return _this.props.value.toString();
        };
        return _this;
    }
    NumberField.prototype.shouldComponentUpdate = function (nextProps) {
        return nextProps.value !== this.props.value || nextProps.disabled !== this.props.disabled;
    };
    NumberField.prototype.render = function () {
        var _a = this.props, disabled = _a.disabled, displayContent = _a.displayContent;
        return (React.createElement(ContentEditable, { content: this.content(), displayContent: displayContent, disabled: disabled, onChange: this.onChange, onKeyPress: this.handleKeyPress }));
    };
    NumberField.defaultProps = {
        disabled: false
    };
    return NumberField;
}(React.Component));
export default NumberField;
//# sourceMappingURL=NumberField.js.map